VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7785
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   16050
   LinkTopic       =   "Form1"
   ScaleHeight     =   7785
   ScaleWidth      =   16050
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   7605
      Left            =   3780
      ScaleHeight     =   7575
      ScaleWidth      =   12165
      TabIndex        =   3
      Top             =   90
      Width           =   12195
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Histogram"
      Height          =   765
      Left            =   90
      TabIndex        =   2
      Top             =   1710
      Width           =   3615
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Show Original"
      Height          =   765
      Left            =   90
      TabIndex        =   1
      Top             =   900
      Width           =   3615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Show D2D1-Effect"
      Height          =   765
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   3615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2022
' https://docs.microsoft.com/en-us/windows/win32/direct2d/built-in-effects

Option Explicit

Private strFile0 As String
Private strFile1 As String
Private pID2D1Image0 As Long
Private pID2D1Image1 As Long


Private Sub Form_Load()
    
    strFile0 = App.Path & "\City.jpg"
    strFile1 = App.Path & "\Spider.png"
    
    Picture1.scaleMode = vbPixels
    
    Command1.Enabled = False
    Command2.Enabled = False
    Command3.Enabled = False
    
    If modD2D1Effects.Initialize Then
    
        Command1.Enabled = True
        Command2.Enabled = True
        Command3.Enabled = True
        
        pID2D1Image0 = ImageFileToD2D1Image(strFile0, NewVector_2F(1, 1))
        pID2D1Image1 = ImageFileToD2D1Image(strFile1, NewVector_2F(1, 1))
        
        Call LoadOriginal
        
    End If
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    Call Release(pID2D1Image0)
    Call Release(pID2D1Image1)

    Call modD2D1Effects.Terminate
    
End Sub

Private Sub Command1_Click()

    Dim pID2D1ImageEffect As Long
    Dim dblTimer As Double
    
    dblTimer = Timer
    
    If pID2D1Image0 <> 0& Then
        If pID2D1Image1 <> 0& Then
        
        
' immer nur einen Effekt aktivieren
'            pID2D1ImageEffect = CreateD2D1TintEffect(pID2D1Image0, NewVector_4F(0.5, 0, 1, 1))
'            pID2D1ImageEffect = CreateD2D1CropEffect(pID2D1Image0, NewVector_4F(50, 50, 300, 300))
'            pID2D1ImageEffect = CreateD2D1TileEffect(pID2D1Image0, NewVector_4F(0, 0, 200, 200))
'            pID2D1ImageEffect = CreateD2D1YCbCrEffect(pID2D1Image0, pID2D1Image1, NewMatrix_3X2)
'            pID2D1ImageEffect = CreateD2D1AtlasEffect(pID2D1Image0, NewVector_4F(0, 0, 200, 200), NewVector_4F(0, 0, 200, 200))
'            pID2D1ImageEffect = CreateD2D1BlendEffect(pID2D1Image0, pID2D1Image1)
'            pID2D1ImageEffect = CreateD2D1FloodEffect(NewVector_4F(0, 0, 0, 1))
'            pID2D1ImageEffect = CreateD2D1SepiaEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1ScaleEffect(pID2D1Image0, NewVector_2F(1.5, 1.5), NewVector_2F(200, 200), 0.5, D2D1_SCALE_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC, D2D1_BORDER_MODE_HARD)
'            pID2D1ImageEffect = CreateD2D1ShadowEffect(pID2D1Image0, NewVector_4F(0, 0, 0, 1), 10)
'            pID2D1ImageEffect = CreateD2D1BorderEffect(pID2D1Image0, D2D1_BORDER_EDGE_MODE_CLAMP, D2D1_BORDER_EDGE_MODE_CLAMP)
'            pID2D1ImageEffect = CreateD2D1EmbossEffect(pID2D1Image0, 5)
'            pID2D1ImageEffect = CreateD2D1InvertEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1SharpenEffect(pID2D1Image0, 2)
'            pID2D1ImageEffect = CreateD2D1OpacityEffect(pID2D1Image0, 0.5)
'            pID2D1ImageEffect = CreateD2D1ExposureEffect(pID2D1Image0, 1)
'            pID2D1ImageEffect = CreateD2D1VignetteEffect(pID2D1Image0, NewVector_4F(1, 0, 0, 1), 0.2, 1)
'            pID2D1ImageEffect = CreateD2D1ContrastEffect(pID2D1Image0, 1)
'            pID2D1ImageEffect = CreateD2D1RgbToHueEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1HueToRgbEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1CrossFadeEffect(pID2D1Image0, pID2D1Image1)
'            pID2D1ImageEffect = CreateD2D1AlphaMaskEffect(pID2D1Image0, pID2D1Image1)
'            pID2D1ImageEffect = CreateD2D1PosterizeEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1GrayscaleEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1ChromaKeyEffect(pID2D1Image0, NewVector_3F, 0.3, False, True)
'            pID2D1ImageEffect = CreateD2D1CompositeEffect(Array(pID2D1Image0, pID2D1Image1), D2D1_COMPOSITE_MODE_MASK_INVERT)
'            pID2D1ImageEffect = CreateD2D1ColorMatrixEffect(pID2D1Image0, NewMatrix_5X4(0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0))
'            pID2D1ImageEffect = CreateD2D13DTransformEffect(pID2D1Image0, NewMatrix_4X4(1, 0.2, 0, 0, 0.2, 1, 0, 0, 0, 0, 1, 0, 20, 20, 20, 1)) 'noch Matrixfunktionen einbauen!!! -> Rotate, Skew usw.
'            pID2D1ImageEffect = CreateD2D1HdrToneMapEffect(pID2D1Image0, 100, 50)
'            pID2D1ImageEffect = CreateD2D1SaturationEffect(pID2D1Image0, 0.2)
'            pID2D1ImageEffect = CreateD2D1StraightenEffect(pID2D1Image0, 25, False, D2D1_STRAIGHTEN_SCALE_MODE_CUBIC)
'            pID2D1ImageEffect = CreateD2D1BrightnessEffect(pID2D1Image0, NewVector_2F, NewVector_2F(0.8, 1))
'            pID2D1ImageEffect = CreateD2D1MorphologyEffect(pID2D1Image0, 5, 5, D2D1_MORPHOLOGY_MODE_DILATE)
'            pID2D1ImageEffect = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 1, 0, True)
'            pID2D1ImageEffect = CreateD2D1PremultiplyEffect(pID2D1Image1)
'            pID2D1ImageEffect = CreateD2D1HueRotationEffect(pID2D1Image0, 90)
'            pID2D1ImageEffect = CreateD2D1GaussianBlurEffect(pID2D1Image0, 3, D2D1_GAUSSIANBLUR_OPTIMIZATION_BALANCED, D2D1_BORDER_MODE_HARD)
'            pID2D1ImageEffect = CreateD2D1LookupTable3DEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1EdgeDetectionEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1TableTransferEffect(pID2D1Image0, NewSingleArray(1, 0.75, 0.5, 0.25, 0), NewSingleArray(1, 0, 1), NewSingleArray(0, 0.25, 0.5, 0.75, 1), NewSingleArray)
'            pID2D1ImageEffect = CreateD2D1GammaTransferEffect(pID2D1Image0, 1, 0.25, 0, 1, 0.25, 0, 1, 0.25, 0, 1, 0.25, 0)
'            pID2D1ImageEffect = CreateD2D1UnpremultiplyEffect(pID2D1Image1)
'            pID2D1ImageEffect = CreateD2D1LinearTransferEffect(pID2D1Image0, -1, -1, -1, 1, 3, 2, 3, 1)
'            pID2D1ImageEffect = CreateD2D1ConvolveMatrixEffect(pID2D1Image0, NewSingleArray(-1, -1, -1, -1, 9, -1, -1, -1, -1), NewVector_2F, NewVector_2F(1, 1), 0.5, -0.5)
'            pID2D1ImageEffect = CreateD2D1ColorManagementEffect(pID2D1Image0, D2D1_COLOR_SPACE_SCRGB, D2D1_COLORMANAGEMENT_RENDERING_INTENT_SATURATION, D2D1_COLOR_SPACE_SRGB, D2D1_COLORMANAGEMENT_RENDERING_INTENT_ABSOLUTE_COLORIMETRIC)
'            pID2D1ImageEffect = CreateD2D1DpiCompensationEffect(pID2D1Image0, NewVector_2F(200, 200))
'            pID2D1ImageEffect = CreateD2D1DirectionalBlurEffect(pID2D1Image0, 3, 45, D2D1_BORDER_MODE_HARD)
'            pID2D1ImageEffect = CreateD2D1TemperatureTintEffect(pID2D1Image0, -0.1, 0.5)
'            pID2D1ImageEffect = CreateD2D1OpacityMetadataEffect(pID2D1Image0, NewVector_4F(0, 0, 200, 200)) '???
'            pID2D1ImageEffect = CreateD2D1DiscreteTransferEffect(pID2D1Image0, NewSingleArray(1, 0.75, 0.5, 0.25, 0), NewSingleArray(1, 0, 1), NewSingleArray(0, 0.25, 0.5, 0.75, 1), NewSingleArray)
'            pID2D1ImageEffect = CreateD2D1LuminanceToAlphaEffect(pID2D1Image0)
'            pID2D1ImageEffect = CreateD2D1HighlightsShadowsEffect(pID2D1Image0, 0, 0.5, 0.2)
'            pID2D1ImageEffect = CreateD2D12DAffineTransformEffect(pID2D1Image0, NewMatrix_3X2(0.9, -0.1, 0.1, 0.9, 50, 70), D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC)
'            pID2D1ImageEffect = CreateD2D1ArithmeticCompositeEffect(pID2D1Image0, pID2D1Image1, NewVector_4F(0, 0.5, 0.5, 0))
'            pID2D1ImageEffect = CreateD2D1WhiteLevelAdjustmentEffect(pID2D1Image0, 80, 60)
'            pID2D1ImageEffect = CreateD2D13DPerspectiveTransformEffect(pID2D1Image0, NewVector_2F, NewVector_3F(-80, 200, 0), NewVector_3F, NewVector_3F, NewVector_3F(-20, -15, -20), 200, D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC)

            Dim pTmp As Long
            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(600, 600), NewVector_2F(0.03, 0.03), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 1, 0, True)
            If pTmp <> 0& Then
                pID2D1ImageEffect = CreateD2D1DisplacementMapEffect(pID2D1Image0, pTmp, 100)
                Call Release(pTmp)
            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_FRACTAL_SUM, 5, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1DistantDiffuseEffect(pTmp, NewVector_3F(1, 1, 1), NewVector_2F(1, 1), 45, 2, 5, 3)
'                Call Release(pTmp)
'            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_FRACTAL_SUM, 5, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1DistantSpecularEffect(pTmp, NewVector_3F(1, 1, 1), NewVector_2F(1, 1), 45, 2, 1, 1, 10)
'                Call Release(pTmp)
'            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 2, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1PointDiffuseEffect(pTmp, NewVector_3F(1, 0, 0), NewVector_3F(250, 250, 0.1), NewVector_2F(1, 1), 30, 2)
'                Call Release(pTmp)
'            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 2, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1PointSpecularEffect(pTmp, NewVector_3F(1, 0, 0), NewVector_3F(250, 250, 0.1), NewVector_2F(1, 1), 10, 10, 2)
'                Call Release(pTmp)
'            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 2, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1SpotDiffuseEffect(pTmp, NewVector_3F(0.5, 0.5, 0.5), NewVector_3F(450, 450, 2), NewVector_2F(1, 1), NewVector_3F(1, 1, 1), 20, 90, 30, 1)
'                Call Release(pTmp)
'            End If

'            Dim pTmp As Long
'            pTmp = CreateD2D1TurbulenceEffect(NewVector_2F(500, 500), NewVector_2F(0.02, 0.02), NewVector_2F, D2D1_TURBULENCE_NOISE_TURBULENCE, 2, 0, True)
'            If pTmp <> 0& Then
'                pID2D1ImageEffect = CreateD2D1SpotSpecularEffect(pTmp, NewVector_3F(1, 0.2, 0.5), NewVector_3F(450, 450, 2), NewVector_2F(1, 1), NewVector_3F(1, 1, 1), 20, 90, 10, 30, 1)
'                Call Release(pTmp)
'            End If



' ----==== mehrere Effekte zusammen geschalten ====----
'            ' ShadowEffekt vom Bild erstellen
'            Dim pShadow As Long
'            pShadow = CreateD2D1ShadowEffect(pID2D1Image0, NewVector_4F(0.2, 0.2, 0.2, 1), 7)
'            If pShadow <> 0& Then
'
'                ' Bild vom ShadowEffekt um 12 Pixel nach unten und rechts verschieben
'                Dim p2DAffineTransform As Long
'                p2DAffineTransform = CreateD2D12DAffineTransformEffect(pShadow, NewMatrix_3X2(1, 0, 0, 1, 12, 12))
'                If p2DAffineTransform <> 0& Then
'
'                    ' Bild vom ShadowEffekt und Bild bereinander zeichnen.
'                    ' Beim D2D1CompositeEffect werden die Bilder in der Reihenfolge bereinander gezeichnet,
'                    ' wie sie im Array angegeben werden! Mindestens 2 Bilder mssen vorhanden sein!
'                    pID2D1ImageEffect = CreateD2D1CompositeEffect(Array(p2DAffineTransform, pID2D1Image0))
'
'                    Call Release(p2DAffineTransform)
'                End If
'                Call Release(pShadow)
'            End If
' ----=============================================----


' ----==== mehrere Effekte zusammen geschalten ====----
'            Dim pBlur As Long
'            pBlur = CreateD2D1GaussianBlurEffect(pID2D1Image0, 50)
'            If pBlur <> 0 Then
'
'                Dim pSpotSpecular As Long
'                pSpotSpecular = CreateD2D1SpotSpecularEffect(pBlur, NewVector_3F(1, 0.3, 0), _
'                                                             NewVector_3F(500, 375, 5), _
'                                                             NewVector_2F(1, 1), _
'                                                             NewVector_3F(1, 1, 1), _
'                                                             15, 90, 10, 30, 1)
'                If pSpotSpecular <> 0 Then
'
'                    Dim pComposite As Long
'                    pComposite = CreateD2D1CompositeEffect(Array(pID2D1Image0, pSpotSpecular), D2D1_COMPOSITE_MODE_SOURCE_IN)
'                    If pComposite <> 0 Then
'
'                        pID2D1ImageEffect = CreateD2D1ArithmeticCompositeEffect(pID2D1Image0, pComposite, NewVector_4F(0, 1, 1, 0))
'
'                        Call Release(pComposite)
'
'                    End If
'
'                    Call Release(pSpotSpecular)
'
'                End If
'
'                Call Release(pBlur)
'
'            End If
' ----=============================================----


            If pID2D1ImageEffect <> 0& Then
            
                Picture1.Picture = Nothing
            
                Picture1.Picture = D2D1ImageToPicture(pID2D1ImageEffect, NewColor_F)
            
                Call Release(pID2D1ImageEffect)
                
                Me.Caption = "Die Berechnung des D2D1-Effekts dauerte = " & CStr(CSng(Timer - dblTimer) * 1000) & "ms"
            
            Else
        
                Picture1.Picture = Nothing
                
                Picture1.Picture = D2D1ImageToPicture(pID2D1Image0, NewColor_F)
            
                Me.Caption = "Der D2D1-Effekts konnte nicht erstellt werden!"
            
            End If
    
        End If
        
    End If
        

End Sub

Private Sub Command2_Click()

    Call LoadOriginal

End Sub

Private Sub Command3_Click()

    Dim lngItem As Long
    Dim lngHistogramDataSize As Long
    Dim sngHistogramData() As Single
    Dim lngColor As Long
    Dim sngMaxValue As Single
    Dim pID2D1Image As Long
    Dim eD2D1_CHANNEL_SELECTOR As D2D1_CHANNEL_SELECTOR
    Dim dblTimer As Double
    
    pID2D1Image = ImageFileToD2D1Image(strFile0, NewVector_2F(1, 1))
    
    If pID2D1Image <> 0& Then
        
        eD2D1_CHANNEL_SELECTOR = D2D1_CHANNEL_SELECTOR_G
        
        dblTimer = Timer
        
        If CreateD2D1HistogramEffect(pID2D1Image, lngHistogramDataSize, sngHistogramData, eD2D1_CHANNEL_SELECTOR) Then
        
            Me.Caption = "Die Berechnung des Histogram-Effekts dauerte = " & CStr(CSng(Timer - dblTimer) * 1000) & "ms"
            
            If lngHistogramDataSize > 0& Then
            
                Picture1.Picture = Nothing
                
                For lngItem = 0 To lngHistogramDataSize - 1
                    If sngHistogramData(lngItem) > sngMaxValue Then sngMaxValue = sngHistogramData(lngItem)
                Next
            
                For lngItem = 0 To lngHistogramDataSize - 1
                
                    Select Case eD2D1_CHANNEL_SELECTOR
                        Case D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_A
                            lngColor = RGB(127, 127, 127)
                        Case D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_R
                            lngColor = RGB(255, 0, 0)
                        Case D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_G
                            lngColor = RGB(0, 255, 0)
                        Case D2D1_CHANNEL_SELECTOR.D2D1_CHANNEL_SELECTOR_B
                            lngColor = RGB(0, 0, 255)
                    End Select

                    Picture1.Line (lngItem * 2, 256)-((lngItem + 1) * 2, 256 - ((sngHistogramData(lngItem) * 256) / sngMaxValue)), lngColor, BF

                Next
            
            End If
            
        End If
        
        Call Release(pID2D1Image)
        
    End If

End Sub

Private Sub LoadOriginal()
    
    Dim pWICBitmap As Long
    Dim dblTimer As Double
    
    dblTimer = Timer
    
    pWICBitmap = ImageFileToWICBitmap(strFile0)
    
    If pWICBitmap <> 0& Then
    
        Picture1.Picture = Nothing

        Picture1.Picture = WICBitmapToPicture(pWICBitmap)
        
        Call Release(pWICBitmap)
        
        Me.Caption = "Das Laden des Bildes per WIC dauerte = " & CStr(CSng(Timer - dblTimer) * 1000) & "ms"
        
    End If

End Sub
